%%%%Homework 6 Problem 3%%%%
%%%Calculate various OLAs%%%
%%%%%%%%%%ECE 537%%%%%%%%%%%
%%%%%by Geoffrey Herman%%%%%

%[s,Fs] = wavread('WhenAllElse8k.wav'); %read in speech file
[s,Fs] = wavread('kp1-g722_64.wav'); %read in speech file
s = s';
figure;  plot([0:1/Fs:(length(s)-1)/Fs],s); %plot original waveform
title('Original sound'); xlabel('time [s]'); 
overlap = 1; %define amount of overlap => overlap:1
L = round(.01*Fs); %calculate length of window
w = window(@hamming,L)'; %create hamming window
fstep = round(L/overlap); %calculate step stize for given overlap

numIter = length(s)/fstep-overlap+1; %calculate the number of frames
shat = zeros(1,numIter*fstep+L-fstep); %%%initialize reconstructed signals
shat2 = zeros(1,numIter*fstep+L-fstep);
shat3 = zeros(1,numIter*fstep+L-fstep);
Frames = zeros(numIter, L); %create Frame matrix
for ii = 1:numIter
    Frames(ii,:) = s((ii-1)*fstep+1:(ii-1)*fstep+L).*w; %create frames by windowing and stepping
end

for ii = 1:numIter
    shat((ii-1)*fstep+1:(ii-1)*fstep+L) = shat((ii-1)*fstep+1:(ii-1)*fstep+L) + Frames(ii,:); %reconstruct s
end
figure;  plot([0:1/Fs:(length(shat)-1)/Fs],shat);
title('OLA reconstruction of s'); xlabel('time [s]'); 

for ii = 1:numIter
    shat2((ii-1)*fstep+1:(ii-1)*fstep+L) = shat((ii-1)*fstep+1:(ii-1)*fstep+L) + Frames(ii,:)*(-1)^ii; %reconstruct s negating everyother frame
end
figure;  plot([0:1/Fs:(length(shat2)-1)/Fs],shat2);
title('OLA reconstruction of s while inverting every other frame'); xlabel('time [s]'); 

for ii = 1:numIter
    Framesfft = conj(fft(Frames(ii,:))); %calculate the conjugate of the FFT of the frame
    Frameshat = ifft(Framesfft); %calculate the inverse FFT
    shat3((ii-1)*fstep+1:(ii-1)*fstep+L) = shat((ii-1)*fstep+1:(ii-1)*fstep+L) + Frameshat; %reconstruct s while conjugating the fft
end
figure;  plot([0:1/Fs:(length(shat3)-1)/Fs],shat3);
title('OLA reconstruction of s with the conjugate of the FFT'); xlabel('time [s]'); 

%%%Write wavefiles%%%
wavwrite(shat,Fs,'OLA.wav');
wavwrite(shat2,Fs,'invertOLA.wav');
wavwrite(shat3,Fs,'conjugateOLA.wav');